Index: trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIMainDialog.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIMainDialog.cpp	(revision 33776)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIMainDialog.cpp	(revision 33778)
@@ -28,5 +28,4 @@
 #include <QEventLoop>
 #include <QApplication>
-#include <QFileIconProvider>
 #include <QDir>
 #include <QUrl>
@@ -186,5 +185,4 @@
                       /* Create some nice looking menu out of the other
                        * directory parts. */
-                      QFileIconProvider fip;
                       QDir dir (fi.absolutePath());
                       do
@@ -194,5 +192,5 @@
                           else
                               action = menu.addAction (dir.dirName());
-                          action->setIcon (fip.icon (QFileInfo (dir, "")));
+                          action->setIcon (vboxGlobal().icon(QFileInfo (dir, "")));
                       }
                       while (dir.cdUp());
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxGlobal.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxGlobal.h	(revision 33776)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxGlobal.h	(revision 33778)
@@ -33,4 +33,5 @@
 #include <QProcess>
 #include <QHash>
+#include <QFileIconProvider>
 
 #ifdef Q_WS_X11
@@ -518,4 +519,7 @@
     }
 
+    QIcon icon(QFileIconProvider::IconType type) { return m_globalIconProvider.icon(type); }
+    QIcon icon(const QFileInfo &info) { return m_globalIconProvider.icon(info); }
+
     QPixmap warningIcon() const { return mWarningIcon; }
     QPixmap errorIcon() const { return mErrorIcon; }
@@ -840,4 +844,6 @@
     QPixmap mWarningIcon, mErrorIcon;
 
+    QFileIconProvider m_globalIconProvider;
+
     friend VBoxGlobal &vboxGlobal();
 };
Index: trunk/src/VBox/Frontends/VirtualBox/src/widgets/VBoxFilePathSelectorWidget.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/widgets/VBoxFilePathSelectorWidget.cpp	(revision 33776)
+++ trunk/src/VBox/Frontends/VirtualBox/src/widgets/VBoxFilePathSelectorWidget.cpp	(revision 33778)
@@ -24,4 +24,5 @@
 #include "UIIconPool.h"
 #include "VBoxFilePathSelectorWidget.h"
+#include "VBoxGlobal.h"
 
 /* Global includes */
@@ -31,5 +32,4 @@
 #include <QClipboard>
 #include <QDir>
-#include <QFileIconProvider>
 #include <QFocusEvent>
 #include <QHBoxLayout>
@@ -66,5 +66,4 @@
 VBoxFilePathSelectorWidget::VBoxFilePathSelectorWidget (QWidget *aParent)
     : QIWithRetranslateUI<QComboBox> (aParent)
-    , mIconProvider (new QFileIconProvider())
     , mCopyAction (new QAction (this))
     , mMode (Mode_Folder)
@@ -107,5 +106,4 @@
 VBoxFilePathSelectorWidget::~VBoxFilePathSelectorWidget()
 {
-    delete mIconProvider;
 }
 
@@ -415,7 +413,7 @@
 {
     if (mMode == Mode_Folder)
-        return mIconProvider->icon (QFileIconProvider::Folder);
+        return vboxGlobal().icon(QFileIconProvider::Folder);
     else
-        return mIconProvider->icon (QFileIconProvider::File);
+        return vboxGlobal().icon(QFileIconProvider::File);
 }
 
@@ -550,5 +548,5 @@
         /* Attach corresponding icon */
         setItemIcon (PathId, QFileInfo (mPath).exists() ?
-                             mIconProvider->icon (QFileInfo (mPath)) :
+                             vboxGlobal().icon(QFileInfo (mPath)) :
                              defaultIcon());
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/widgets/VBoxFilePathSelectorWidget.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/widgets/VBoxFilePathSelectorWidget.h	(revision 33776)
+++ trunk/src/VBox/Frontends/VirtualBox/src/widgets/VBoxFilePathSelectorWidget.h	(revision 33778)
@@ -32,5 +32,4 @@
 /* Qt forward declarations */
 class QHBoxLayout;
-class QFileIconProvider;
 class QAction;
 class QPushButton;
@@ -111,5 +110,4 @@
 
     /* Private member vars */
-    QFileIconProvider *mIconProvider;
     QAction *mCopyAction;
     Mode mMode;